/*
 * $Id: ChmapFrame.java,v 1.2 2002/08/14 15:05:34 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.chmap;

import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;

/**
 * Chmap graph frame.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version $Revision: 1.2 $
 */
public class ChmapFrame extends JFrame {

  private static final int WIDTH = 640, HEIGHT = 640;

  ChmapPanel graphArea;

  public ChmapFrame() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setTitle("Chmap");
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    graphArea = new ChmapPanel();
    this.getContentPane().setLayout(new BorderLayout());
    this.getContentPane().add(graphArea, BorderLayout.CENTER);
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(1);
  }

  public void showChmapNodes(Hashtable nodes) {
    ChmapLayouter layouter = new ChmapLayouter();
    Vector nodePoints = layouter.layoutChmapNodes(nodes);
    ChmapDrawer drawer = new ChmapDrawer();
    drawer.setNodePoints(nodePoints);
    drawer.setNodePointsRange(layouter.xMin, layouter.xMax, layouter.yMin, layouter.yMax);
    graphArea.setDrawer(drawer);
    setSize(WIDTH, HEIGHT);
    setVisible(true);
    repaint();
  }
}
