/*
 * $Id: ChmapImageDrawer.java,v 1.1.1.1 2002/07/24 13:42:01 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.chmap;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;

/**
 * Make JPEG image form nodes.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version $Revision: 1.1.1.1 $
 */
public class ChmapImageDrawer {

  private final int WIDTH = 640, HEIGHT = 640;

  public void drawChmapNodes(Hashtable nodes, String fileName) throws
   FileNotFoundException, IOException {
    ChmapLayouter layouter = new ChmapLayouter();
    Vector nodePoints = layouter.layoutChmapNodes(nodes);
    ChmapDrawer drawer = new ChmapDrawer();
    drawer.setNodePoints(nodePoints);
    drawer.setNodePointsRange(layouter.xMin, layouter.xMax, layouter.yMin, layouter.yMax);
    BufferedImage image = new BufferedImage(WIDTH, HEIGHT, BufferedImage.TYPE_INT_RGB);
    Graphics2D g = image.createGraphics();
    Dimension dim = new Dimension(WIDTH, HEIGHT);
    drawer.showNodes(g, dim);

    FileOutputStream os = new FileOutputStream(fileName);
    JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(os);
    encoder.encode(image);
    os.close();
  }
}
